#include "testlib.h"
#include <ctype.h>
#include <math.h>
using namespace std;

typedef pair<int, int> pii;

const int MAX = 200000;
vector<int> A, B, C;

int count_collisions(vector<int> a, vector<int> b) {
    int n = a.size();
	set<int> doors;
	for (int i = 0; i < n; ++i) if (a[i] == 0) doors.insert(i);
	doors.insert(-n-n);
	doors.insert(+n+n);

	set<pii> used;
	int result = 0;

	for (int i = 0; i < n; ++i)
		if (a[i] == 0) {
		    if (b[i] != i)
    			return -1;
		} else {
			int rg = *doors.lower_bound(i);
			int lf = *(--doors.lower_bound(i));

			int dl = i - lf;
			int dr = rg - i;

			if (dl != dr) {
				if (dl < dr) {
					if (b[i] != lf)
					    return -1;
					result += used.count(pii(lf, dl));
					used.insert(pii(lf, dl));
				} else {
				    if (b[i] != rg)
    					return -1;
					result += used.count(pii(rg, dr));
					used.insert(pii(rg, dr));
				}
			} else {
			    if (b[i] != lf && b[i] != rg)
			        return -1;
			        
				if (b[i] == rg) {
					result += used.count(pii(rg, dr));
					used.insert(pii(rg, dr));
				} else {
					result += used.count(pii(lf, dl));
					used.insert(pii(lf, dl));
				}
			}
		}
    return result;
}

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);

    int N = inf.readInt();
    int k1 = ans.readInt();
    int k2 = ouf.readInt();
	A.resize(N);
	B.resize(N);
	C.resize(N);

    for (int i = 0; i < N; ++i) {
        A[i] = inf.readInt(0, 1);
        C[i] = ans.readInt(1, N) - 1;
        B[i] = ouf.readInt(1, N) - 1;
    }    
    
	if (count_collisions(A, C) < 0)
		quitf(_fail, "Incorrect answer");
	
    if (k1 != count_collisions(A, C))
		quitf(_fail, "Wrong number of collisions");
    
	if (count_collisions(A, B) < 0)
		quitf(_wa, "Incorrect answer");
	
    if (k2 != count_collisions(A, B))
       quitf(_wa, "Real counter of conflicts %d is not equal %d", count_collisions(A, B), k2);
   
     if (k1 < k2)
        quitf(_wa, "Not optimal");     
     if (k1 > k2)
        quitf(_fail, "Conflict counter less than jury");
             
    quitf(_ok, "Correct answer.");
}
