#include <bits/stdc++.h>
#include "testlib.h"

using namespace std;

const int N = 300 * 1000;
const string NO_SOLUTION = "-1";

int count0(const string& s) {
    int res = 0;
    for (int i = 0; i < (int) s.length(); i++)
        if (s[i] == '0')
            res++;
    return res;
}

bool checkPeriod(const string& s) {
    int n = s.length();
    int a = 0;
    if (s[0] != '0')
        return false;
    while (a < n && s[a] == '0')
        a++;
    if (a == n)
        return true;
    int b = 0;
    while (b < n && s[a + b] == '1')
        b++;
    for (int i = 0; i < n; i++) {
        char c = '0';
        if (i % (a + b) >= a)
            c = '1';
        if (c != s[i])
            return false;
    }
    return true;    
}

bool valid(const string& inp, const string& out) {
    if (count0(out) == 0)
        return false;
    if (inp.length() != out.length())
        return false;
    for (int i = 0; i < (int) out.length(); i++)
        if (out[i] != '0' && out[i] != '1')
            return false;
    for (int i = 0; i < (int) inp.length(); i++)
        if (inp[i] != '?' && inp[i] != out[i])
            return false;
    return checkPeriod(out);
}

int main(int argc, char** argv) {
	registerTestlibCmd(argc, argv);
    string inp = inf.readString();
    int n = inp.length();
    string exp_ans = ans.readString();
    string got_ans = ouf.readString();
    if (exp_ans == NO_SOLUTION) {
        if (got_ans == NO_SOLUTION)
            quitf(_ok, "No solution");
        if (valid(inp, got_ans))
            quitf(_fail, "Jury has no answer but a participant has one");
        quitf(_wa, "Participant's answer is not a zebra consistent with the input"); 
    }
    if (!valid(inp, exp_ans))
        quitf(_fail, "Jury's answer is not a zebra consistent with the input");
    if (!valid(inp, got_ans))
        quitf(_wa, "Participant's answer is not a zebra consistent with the input");
    int exp0 = count0(exp_ans);
    int got0 = count0(got_ans);
    if (got0 < exp0)
        quitf(_fail, "Participant's answer is better");
    if (got0 > exp0)
        quitf(_wa, "Jury has a better answer");     
    quitf(_ok, "Participant's answer is optimal");
}

