#include <bits/stdc++.h>

using namespace std;

const string NO_SOLUTION = "-1";

vector<int> getLeft0(const string& s) {
    int n = s.length();
    vector<int> res(n);
    int last = -1;
    for (int i = 0; i < n; i++) {
        if (s[i] == '0')
            last = i;
        res[i] = last;
    }
    return res;
}

vector<int> getRight1(const string& s) {
    int n = s.length();
    vector<int> res(n);
    int last = n;
    for (int i = n - 1; i >= 0; i--) {
        if (s[i] == '1')
            last = i;
        res[i] = last;
    }
    return res;
}

int count0(int a, int b, int n) {
    return n / (a + b) * a + min(a, n % (a + b)); 
}

bool in_range(int a, int b, int x) {
    return a <= x && x <= b;
}

int getMinA(const vector<int>& left0, const vector<int>& right1, int sum) {
    int n = left0.size();
    int maxLast0 = 0;
    int minFirst1 = sum;
    for (int i = 0; i < n; i += sum) {
        int low = i;
        int high = min(low + sum - 1, n - 1);
        int last0 = left0[high];
        int first1 = right1[low];
        if (in_range(low, high, last0))
            maxLast0 = max(maxLast0, last0 - low);
        if (in_range(low, high, first1))
            minFirst1 = min(minFirst1, first1 - low);  
    }                    
    if (maxLast0 >= minFirst1)
        return 0;
    return maxLast0 + 1;
}

string generate(int a, int b, int n) {
    string res = "";
    for (int i = 0; i < n; i++)
        res += (i % (a + b) < a) ? '0' : '1';
    return res;  
}

string solve(const string& s) {
    pair<int, int> bestAB;
    int n = s.length();
    vector<int> left0 = getLeft0(s);
    vector<int> right1 = getRight1(s);
    for (int sum = 1; sum <= n; sum++) {
        int curA = getMinA(left0, right1, sum);
        if (curA == 0)
            continue;
        int curB = sum - curA;
        if (bestAB == pair<int, int>() 
            || count0(bestAB.first, bestAB.second, n) > count0(curA, curB, n))
            bestAB = pair<int, int>(curA, curB);         
    }
    if (bestAB == pair<int, int>())
        return NO_SOLUTION;
    return generate(bestAB.first, bestAB.second, n);      
}

int main() {
    ios_base::sync_with_stdio(0);
    string s;
    cin >> s;
    cout << solve(s) << endl;      
    return 0;
}

