#include <iostream>
#include <fstream>
#include <set>
#include <algorithm>
#include <vector>

using namespace std;

enum BorderState {
  OPEN, 
  CLOSE,
};

struct SegmentBorder {
  long long coordinate;
  BorderState state;

  bool operator<(const SegmentBorder &s) {
    return coordinate < s.coordinate || (coordinate == s.coordinate && state < s.state);
  }
};

struct Segment {
  long long l;
  long long r;
};

int main() {
  //ifstream fin("input.txt");
  //ofstream fout("output.txt");
  //istream& in = fin;
  //ostream& out = fout;

  istream& in = cin;
  ostream& out = cout;

  int n;
  long long d;
  in >> n >> d;
  vector<SegmentBorder> borders;
  vector<Segment> segments(n);
  for (int i = 0; i < n; ++i) {
    in >> segments[i].l >> segments[i].r;

    if (segments[i].r - segments[i].l + 1 >= d) {
      segments[i].l = 0;
      segments[i].r = d - 1;
    } else {
      segments[i].l %= d;
      segments[i].r %= d;
    }
    borders.push_back({ segments[i].l, OPEN });
    borders.push_back({ segments[i].r, CLOSE });
  }

  sort(borders.begin(), borders.end());

  int covered = 0;
  for (unsigned i = 0; i < segments.size(); ++i) {
    covered += (segments[i].l > segments[i].r);
  }

  int max_events = covered;
  long long best_d = 0;
  for (unsigned curr_index = 0; curr_index < borders.size(); ++curr_index) {
    if (borders[curr_index].state == OPEN) {
      covered += 1;
      if (max_events < covered) {
        max_events = covered;
        best_d = borders[curr_index].coordinate;
      }
    } else {
      covered -= 1;
    }
  }

  out << max_events << " " << best_d << endl;
  return 0;
}
